# coding: utf-8

# flake8: noqa

"""
    Voicegain Speech Recognition API v1

    # New  [RTC Callback API](#tag/aivr-callback) for building interactive speech-enabled phone applications  (IVR, Voicebots, etc.).    # Intro to Voicegain API This API is provided by [Voicegain](https://www.voicegain.ai) to its registered customers.  In addition to this API Spec document please also consult our Knowledge Base Articles: * [Web API Section](https://support.voicegain.ai/hc/en-us/categories/360001288691-Web-API) of our Knowledge Base   * [Authentication for Web API](https://support.voicegain.ai/hc/en-us/sections/360004485831-Authentication-for-Web-API) - how to generate and use JWT   * [Basic Web API Use Cases](https://support.voicegain.ai/hc/en-us/sections/360004660632-Basic-Web-API-Use-Cases)   * [Example applications using Voicegain API](https://support.voicegain.ai/hc/en-us/sections/360009682932-Example-applications-using-Voicegain-API)  **NOTE:** Most of the request and response examples in this API document are generated from schema example annotation. This may result in the response example not matching the request data example.</br> We will be adding specific examples to certain API methods if we notice that this is needed to clarify the usage.  # Speech-to-Text: Recognition vs Transcription Voicegain web api provides two types of methods for speech recognition.   + **/asr/recognize** - where the purpose is to identify what was said in a context of a more constrained set of choices.   This web api uses grammars as both a language model and a way to attach semantic meaning to spoken utterances. + **/asr/transcribe** - where the purpose is to **transcribe** speech audio word for word, no meaning is attached to transcribed text.   This web api uses large vocabulary language model.      The result of transcription can be returned in three formats. These are requested inside session[].content when making initial transcribe request:  + **Transcript** - Contains the complete text of transcription + **Words** - Intermediate results will contain new words, with timing and confidences, since the previous intermediate result. The final result will contain complete transcription. + **Word-Tree** - Contains a tree of all feasible alternatives. Use this when integrating with NL postprocessing to determine the final utterance and its meaning. + **Captions** - Intermediate results will be suitable to use as captions (this feature is in beta).  # Async Sessions: Real-Time, Semi Real-Time, and Off-Line  There are 3 types of Async ASR session that can be started:  + **REAL-TIME** - Real-time processing of streaming audio. For the recognition API, results are available within less than one second.  For the transcription API, real-time incremental results will be sent back with about 2 seconds delay.  + **OFF-LINE** - offline transcription or recognition. Has higher accuracy than REAL-TIME. Results are delivered once the complete audio has been processed.  Currently, 1 hour long audio is processed in about 10 minutes. + **SEMI-REAL-TIME** - Similar in use to REAL-TIME, but the results are available with a delay of about 30 seconds (or earlier for shorter audio). Same accuracy as OFF-LINE.  It is possible to start up to 2 simultaneous sessions attached to the same audio.   The allowed combinations of the types of two sessions are:  + REAL-TIME + SEMI-REAL-TIME - one possible use case is a combination of live transcription with transcription for online streaming (which may be delayed w.r.t of real time). The benefit of using separate SEMI-REAL-TIME session is that it has higher accuracy. + REAL-TIME + OFF-LINE - one possible use case is combination of live transcription with higher quality off-line transcription for archival purposes.  Other combinations of session types, including more than 2 sessions, are currently not supported.  Please, let us know if you think you have a valid use case for other combinations.   # Audio Input  The speech audio can be submitted in variety of ways:  + **Inline** - Short audio data can be encoded inside a request as a base64 string. + **Retrieved from URL** - Audio can be retrieved from a provided URL. The URL can also point to a live stream. + **Streamed via RTP** - Recommended only for Edge use cases (not for Cloud). + **Streamed via proprietary UDP protocol** - We provide a Java utility to do this. The utility can stream directly from an audio device, or from a file. + **Streamed via Websocket** - Can be used, e.g., to do microphone capture directly from the web browser. + **From Object Store** - Currently it works only with files uploaded to Voicegain object store, but will be expanded to support other Object Stores.   # JWT Authentication Almost all methods from this API require authentication by means of a JWT Token. A valid token can be obtained from the [Voicegain Portal](https://portal.voicegain.ai).   Each Context within the Account has its own JWT token. The accountId and contextId are encoded inside the token,  that is why API method requests do not require these in their request parameters.  More information about generating and using JWT with Voicegain API can be found in our  [Support Pages](https://support.voicegain.ai/hc/en-us/articles/360028023691-JWT-Authentication).   # noqa: E501

    The version of the OpenAPI document: 1.11.0 - updated July 31, 2020
    Contact: api.support@voicegain.ai
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

__version__ = "1.0.0"

# import apis into sdk package
from ascalon_web_api_client.api.aivr_api import AivrApi
from ascalon_web_api_client.api.aivr_callback_api import AivrCallbackApi
from ascalon_web_api_client.api.data_api import DataApi
from ascalon_web_api_client.api.greg_api import GregApi
from ascalon_web_api_client.api.lm_api import LmApi
from ascalon_web_api_client.api.recognize_api import RecognizeApi
from ascalon_web_api_client.api.security_api import SecurityApi
from ascalon_web_api_client.api.training_api import TrainingApi
from ascalon_web_api_client.api.transcribe_api import TranscribeApi
from ascalon_web_api_client.api.websocket_api import WebsocketApi

# import ApiClient
from ascalon_web_api_client.api_client import ApiClient
from ascalon_web_api_client.configuration import Configuration
from ascalon_web_api_client.exceptions import OpenApiException
from ascalon_web_api_client.exceptions import ApiTypeError
from ascalon_web_api_client.exceptions import ApiValueError
from ascalon_web_api_client.exceptions import ApiKeyError
from ascalon_web_api_client.exceptions import ApiException
# import models into sdk package
from ascalon_web_api_client.models.aivr_callback_response import AIVRCallbackResponse
from ascalon_web_api_client.models.aivr_callback_response_final import AIVRCallbackResponseFinal
from ascalon_web_api_client.models.aivr_conference_transfer import AIVRConferenceTransfer
from ascalon_web_api_client.models.aivr_disconnect import AIVRDisconnect
from ascalon_web_api_client.models.aivr_event import AIVREvent
from ascalon_web_api_client.models.aivr_event_type import AIVREventType
from ascalon_web_api_client.models.aivr_existing_session import AIVRExistingSession
from ascalon_web_api_client.models.aivr_logic import AIVRLogic
from ascalon_web_api_client.models.aivr_logic_media import AIVRLogicMedia
from ascalon_web_api_client.models.aivr_logic_transfer import AIVRLogicTransfer
from ascalon_web_api_client.models.aivr_logic_type import AIVRLogicType
from ascalon_web_api_client.models.aivr_new_session import AIVRNewSession
from ascalon_web_api_client.models.aivr_phone_transfer import AIVRPhoneTransfer
from ascalon_web_api_client.models.aivr_prompt import AIVRPrompt
from ascalon_web_api_client.models.aivr_prompt_completion import AIVRPromptCompletion
from ascalon_web_api_client.models.aivr_prompt_playing import AIVRPromptPlaying
from ascalon_web_api_client.models.aivr_prompt_properties_audio import AIVRPromptPropertiesAudio
from ascalon_web_api_client.models.aivr_prompt_properties_html import AIVRPromptPropertiesHtml
from ascalon_web_api_client.models.aivr_question import AIVRQuestion
from ascalon_web_api_client.models.aivr_recognition_result import AIVRRecognitionResult
from ascalon_web_api_client.models.aivr_recording import AIVRRecording
from ascalon_web_api_client.models.aivr_response_properties_audio import AIVRResponsePropertiesAudio
from ascalon_web_api_client.models.aivr_response_properties_html import AIVRResponsePropertiesHtml
from ascalon_web_api_client.models.aivrs_question_specifics import AIVRSQuestionSpecifics
from ascalon_web_api_client.models.aivr_session_user import AIVRSessionUser
from ascalon_web_api_client.models.aivr_session_user_base import AIVRSessionUserBase
from ascalon_web_api_client.models.aivr_session_user_fs import AIVRSessionUserFS
from ascalon_web_api_client.models.aivr_transfer import AIVRTransfer
from ascalon_web_api_client.models.account_and_context_id import AccountAndContextId
from ascalon_web_api_client.models.asr_processing_event import AsrProcessingEvent
from ascalon_web_api_client.models.asr_processing_status import AsrProcessingStatus
from ascalon_web_api_client.models.asr_recognition_result import AsrRecognitionResult
from ascalon_web_api_client.models.asr_settings_common import AsrSettingsCommon
from ascalon_web_api_client.models.asr_settings_recognition import AsrSettingsRecognition
from ascalon_web_api_client.models.asr_settings_recognition_all_of import AsrSettingsRecognitionAllOf
from ascalon_web_api_client.models.asr_settings_recognition_defaults import AsrSettingsRecognitionDefaults
from ascalon_web_api_client.models.asr_settings_recognition_defaults_all_of import AsrSettingsRecognitionDefaultsAllOf
from ascalon_web_api_client.models.asr_settings_transcription import AsrSettingsTranscription
from ascalon_web_api_client.models.asr_settings_transcription_all_of import AsrSettingsTranscriptionAllOf
from ascalon_web_api_client.models.async_audio_input_source import AsyncAudioInputSource
from ascalon_web_api_client.models.async_mode import AsyncMode
from ascalon_web_api_client.models.async_mode_recognition import AsyncModeRecognition
from ascalon_web_api_client.models.async_mode_transcription import AsyncModeTranscription
from ascalon_web_api_client.models.async_post_response_base import AsyncPostResponseBase
from ascalon_web_api_client.models.async_post_response_base_audio import AsyncPostResponseBaseAudio
from ascalon_web_api_client.models.async_reco_post_response import AsyncRecoPostResponse
from ascalon_web_api_client.models.async_reco_post_response_all_of import AsyncRecoPostResponseAllOf
from ascalon_web_api_client.models.async_recognition_request import AsyncRecognitionRequest
from ascalon_web_api_client.models.async_recognition_response import AsyncRecognitionResponse
from ascalon_web_api_client.models.async_recognition_result import AsyncRecognitionResult
from ascalon_web_api_client.models.async_recognition_result_all_of import AsyncRecognitionResultAllOf
from ascalon_web_api_client.models.async_result_full import AsyncResultFull
from ascalon_web_api_client.models.async_result_full_all_of import AsyncResultFullAllOf
from ascalon_web_api_client.models.async_result_full_all_of_audio import AsyncResultFullAllOfAudio
from ascalon_web_api_client.models.async_result_full_all_of_audio_source import AsyncResultFullAllOfAudioSource
from ascalon_web_api_client.models.async_result_full_all_of_audio_source_data_store import AsyncResultFullAllOfAudioSourceDataStore
from ascalon_web_api_client.models.async_result_full_all_of_result import AsyncResultFullAllOfResult
from ascalon_web_api_client.models.async_result_incremental import AsyncResultIncremental
from ascalon_web_api_client.models.async_result_incremental_detail import AsyncResultIncrementalDetail
from ascalon_web_api_client.models.async_result_incremental_detail_result import AsyncResultIncrementalDetailResult
from ascalon_web_api_client.models.async_session_established import AsyncSessionEstablished
from ascalon_web_api_client.models.async_session_short_info import AsyncSessionShortInfo
from ascalon_web_api_client.models.async_transc_post_response import AsyncTranscPostResponse
from ascalon_web_api_client.models.async_transc_post_response_all_of import AsyncTranscPostResponseAllOf
from ascalon_web_api_client.models.async_transc_session_established import AsyncTranscSessionEstablished
from ascalon_web_api_client.models.async_transc_session_established_all_of import AsyncTranscSessionEstablishedAllOf
from ascalon_web_api_client.models.async_transcription_request import AsyncTranscriptionRequest
from ascalon_web_api_client.models.async_transcription_response import AsyncTranscriptionResponse
from ascalon_web_api_client.models.async_transcription_response_shared import AsyncTranscriptionResponseShared
from ascalon_web_api_client.models.audio_channel import AudioChannel
from ascalon_web_api_client.models.audio_format import AudioFormat
from ascalon_web_api_client.models.audio_input_async import AudioInputAsync
from ascalon_web_api_client.models.audio_input_async_all_of import AudioInputAsyncAllOf
from ascalon_web_api_client.models.audio_input_base import AudioInputBase
from ascalon_web_api_client.models.audio_input_data import AudioInputData
from ascalon_web_api_client.models.audio_input_data_all_of import AudioInputDataAllOf
from ascalon_web_api_client.models.audio_input_data_all_of_source import AudioInputDataAllOfSource
from ascalon_web_api_client.models.audio_input_sync import AudioInputSync
from ascalon_web_api_client.models.audio_input_sync_all_of import AudioInputSyncAllOf
from ascalon_web_api_client.models.audio_resource_uri import AudioResourceUri
from ascalon_web_api_client.models.audio_resource_uri_all_of import AudioResourceUriAllOf
from ascalon_web_api_client.models.builtin import BUILTIN
from ascalon_web_api_client.models.builtin_all_of import BUILTINAllOf
from ascalon_web_api_client.models.callback_req import CallbackReq
from ascalon_web_api_client.models.callback_resp import CallbackResp
from ascalon_web_api_client.models.caption import Caption
from ascalon_web_api_client.models.content_type import ContentType
from ascalon_web_api_client.models.core_aivr_session import CoreAIVRSession
from ascalon_web_api_client.models.core_aivr_session_telco_data import CoreAIVRSessionTelcoData
from ascalon_web_api_client.models.creating_entity import CreatingEntity
from ascalon_web_api_client.models.data_obj_ref import DataObjRef
from ascalon_web_api_client.models.data_object import DataObject
from ascalon_web_api_client.models.data_object_all_of import DataObjectAllOf
from ascalon_web_api_client.models.data_object_base import DataObjectBase
from ascalon_web_api_client.models.data_object_ids import DataObjectIds
from ascalon_web_api_client.models.data_object_modifiable import DataObjectModifiable
from ascalon_web_api_client.models.data_object_with_audio import DataObjectWithAudio
from ascalon_web_api_client.models.data_object_with_audio_all_of import DataObjectWithAudioAllOf
from ascalon_web_api_client.models.debug_info import DebugInfo
from ascalon_web_api_client.models.debug_settings import DebugSettings
from ascalon_web_api_client.models.disconnect import Disconnect
from ascalon_web_api_client.models.disconnect_all_of import DisconnectAllOf
from ascalon_web_api_client.models.error import Error
from ascalon_web_api_client.models.error_all_of import ErrorAllOf
from ascalon_web_api_client.models.error_info import ErrorInfo
from ascalon_web_api_client.models.estimated_queue_wait import EstimatedQueueWait
from ascalon_web_api_client.models.experiment_platform import ExperimentPlatform
from ascalon_web_api_client.models.file_location import FileLocation
from ascalon_web_api_client.models.greg import GREG
from ascalon_web_api_client.models.greg_all_of import GREGAllOf
from ascalon_web_api_client.models.grxml import GRXML
from ascalon_web_api_client.models.grxml_all_of import GRXMLAllOf
from ascalon_web_api_client.models.grammar import Grammar
from ascalon_web_api_client.models.greg_audio import GregAudio
from ascalon_web_api_client.models.greg_audio_all_of import GregAudioAllOf
from ascalon_web_api_client.models.greg_audio_base import GregAudioBase
from ascalon_web_api_client.models.greg_audio_base_with_audio import GregAudioBaseWithAudio
from ascalon_web_api_client.models.greg_audio_id import GregAudioId
from ascalon_web_api_client.models.greg_audio_input import GregAudioInput
from ascalon_web_api_client.models.greg_audio_input_audio_hash import GregAudioInputAudioHash
from ascalon_web_api_client.models.greg_audio_input_audio_id import GregAudioInputAudioId
from ascalon_web_api_client.models.greg_audio_set import GregAudioSet
from ascalon_web_api_client.models.greg_audio_set_base import GregAudioSetBase
from ascalon_web_api_client.models.greg_audio_set_base_inclusive import GregAudioSetBaseInclusive
from ascalon_web_api_client.models.greg_audio_set_core import GregAudioSetCore
from ascalon_web_api_client.models.greg_audio_set_id import GregAudioSetId
from ascalon_web_api_client.models.greg_audio_set_inclusive import GregAudioSetInclusive
from ascalon_web_api_client.models.greg_audio_set_inclusive_core import GregAudioSetInclusiveCore
from ascalon_web_api_client.models.greg_audio_set_inner import GregAudioSetInner
from ascalon_web_api_client.models.greg_audio_set_response import GregAudioSetResponse
from ascalon_web_api_client.models.greg_audio_thin import GregAudioThin
from ascalon_web_api_client.models.greg_experiment import GregExperiment
from ascalon_web_api_client.models.greg_experiment_base import GregExperimentBase
from ascalon_web_api_client.models.greg_experiment_base_inclusive import GregExperimentBaseInclusive
from ascalon_web_api_client.models.greg_experiment_base_platform_data import GregExperimentBasePlatformData
from ascalon_web_api_client.models.greg_experiment_id import GregExperimentId
from ascalon_web_api_client.models.greg_experiment_inclusive import GregExperimentInclusive
from ascalon_web_api_client.models.greg_experiment_modifiable import GregExperimentModifiable
from ascalon_web_api_client.models.greg_experiment_platform_external_asr import GregExperimentPlatformExternalASR
from ascalon_web_api_client.models.greg_experiment_platform_upload import GregExperimentPlatformUpload
from ascalon_web_api_client.models.greg_experiment_platform_voicegain import GregExperimentPlatformVoicegain
from ascalon_web_api_client.models.greg_experiment_response import GregExperimentResponse
from ascalon_web_api_client.models.greg_experiment_status import GregExperimentStatus
from ascalon_web_api_client.models.greg_experiment_status_modifiable import GregExperimentStatusModifiable
from ascalon_web_api_client.models.greg_grammar import GregGrammar
from ascalon_web_api_client.models.greg_grammar_base import GregGrammarBase
from ascalon_web_api_client.models.greg_grammar_base_light import GregGrammarBaseLight
from ascalon_web_api_client.models.greg_grammar_id import GregGrammarId
from ascalon_web_api_client.models.greg_grammar_inner import GregGrammarInner
from ascalon_web_api_client.models.greg_grammar_light import GregGrammarLight
from ascalon_web_api_client.models.greg_interpretation import GregInterpretation
from ascalon_web_api_client.models.greg_question import GregQuestion
from ascalon_web_api_client.models.greg_question_base import GregQuestionBase
from ascalon_web_api_client.models.greg_question_id import GregQuestionId
from ascalon_web_api_client.models.greg_question_inner import GregQuestionInner
from ascalon_web_api_client.models.greg_recog_base_no_exp_nlsml_core import GregRecogBaseNoExpNlsmlCore
from ascalon_web_api_client.models.greg_recog_base_no_exp_obj_core import GregRecogBaseNoExpObjCore
from ascalon_web_api_client.models.greg_recog_base_no_exp_obj_or_nlsml import GregRecogBaseNoExpObjOrNlsml
from ascalon_web_api_client.models.greg_recog_base_obj_or_nlsml import GregRecogBaseObjOrNlsml
from ascalon_web_api_client.models.greg_recog_base_with_exp import GregRecogBaseWithExp
from ascalon_web_api_client.models.greg_recognition import GregRecognition
from ascalon_web_api_client.models.greg_recognition_base import GregRecognitionBase
from ascalon_web_api_client.models.greg_recognition_id import GregRecognitionId
from ascalon_web_api_client.models.greg_review_status import GregReviewStatus
from ascalon_web_api_client.models.greg_source_of_truth import GregSourceOfTruth
from ascalon_web_api_client.models.greg_truth_update import GregTruthUpdate
from ascalon_web_api_client.models.greg_truth_updates import GregTruthUpdates
from ascalon_web_api_client.models.gui_input import GuiInput
from ascalon_web_api_client.models.hangup import Hangup
from ascalon_web_api_client.models.html_checkbox import HtmlCheckbox
from ascalon_web_api_client.models.html_choice_item import HtmlChoiceItem
from ascalon_web_api_client.models.html_radio_buttons import HtmlRadioButtons
from ascalon_web_api_client.models.html_text_entry import HtmlTextEntry
from ascalon_web_api_client.models.if_exists import IfExists
from ascalon_web_api_client.models.inline_data import InlineData
from ascalon_web_api_client.models.inline_object import InlineObject
from ascalon_web_api_client.models.inline_object1 import InlineObject1
from ascalon_web_api_client.models.input import Input
from ascalon_web_api_client.models.input_all_of import InputAllOf
from ascalon_web_api_client.models.jjsgf import JJSGF
from ascalon_web_api_client.models.jjsgf_all_of import JJSGFAllOf
from ascalon_web_api_client.models.lm_type import LMType
from ascalon_web_api_client.models.lang_model_status import LangModelStatus
from ascalon_web_api_client.models.language_model_doc import LanguageModelDoc
from ascalon_web_api_client.models.language_model_doc_modifiable import LanguageModelDocModifiable
from ascalon_web_api_client.models.language_model_src_data import LanguageModelSrcData
from ascalon_web_api_client.models.mrcp_version import MRCPVersion
from ascalon_web_api_client.models.mrc_pv1_asr_settings import MRCPv1AsrSettings
from ascalon_web_api_client.models.mrc_pv2_asr_settings import MRCPv2AsrSettings
from ascalon_web_api_client.models.non_session_error_response import NonSessionErrorResponse
from ascalon_web_api_client.models.output import Output
from ascalon_web_api_client.models.output_all_of import OutputAllOf
from ascalon_web_api_client.models.poll_req import PollReq
from ascalon_web_api_client.models.poll_resp import PollResp
from ascalon_web_api_client.models.portal_output_init import PortalOutputInit
from ascalon_web_api_client.models.progress import Progress
from ascalon_web_api_client.models.progress_phase import ProgressPhase
from ascalon_web_api_client.models.reco_alt import RecoAlt
from ascalon_web_api_client.models.recog_nlsml import RecogNlsml
from ascalon_web_api_client.models.recog_nlsml_no_exp import RecogNlsmlNoExp
from ascalon_web_api_client.models.recog_obj import RecogObj
from ascalon_web_api_client.models.recog_obj_no_exp import RecogObjNoExp
from ascalon_web_api_client.models.recognition_result import RecognitionResult
from ascalon_web_api_client.models.requested_content import RequestedContent
from ascalon_web_api_client.models.resource_uri import ResourceUri
from ascalon_web_api_client.models.sample_rate import SampleRate
from ascalon_web_api_client.models.separate_audio import SeparateAudio
from ascalon_web_api_client.models.session_error_response import SessionErrorResponse
from ascalon_web_api_client.models.session_init_recognition import SessionInitRecognition
from ascalon_web_api_client.models.session_init_transcription import SessionInitTranscription
from ascalon_web_api_client.models.settings_async_transcription import SettingsAsyncTranscription
from ascalon_web_api_client.models.settings_recognition import SettingsRecognition
from ascalon_web_api_client.models.settings_sync_transcription import SettingsSyncTranscription
from ascalon_web_api_client.models.sos_ref import SosRef
from ascalon_web_api_client.models.stream_resp import StreamResp
from ascalon_web_api_client.models.stream_setup import StreamSetup
from ascalon_web_api_client.models.streaming_protocol import StreamingProtocol
from ascalon_web_api_client.models.sync_audio_input_source import SyncAudioInputSource
from ascalon_web_api_client.models.sync_recognition_request import SyncRecognitionRequest
from ascalon_web_api_client.models.sync_recognition_response import SyncRecognitionResponse
from ascalon_web_api_client.models.sync_session_established import SyncSessionEstablished
from ascalon_web_api_client.models.sync_transcription_request import SyncTranscriptionRequest
from ascalon_web_api_client.models.sync_transcription_response import SyncTranscriptionResponse
from ascalon_web_api_client.models.sync_transcription_result import SyncTranscriptionResult
from ascalon_web_api_client.models.training_set_bucket_type import TrainingSetBucketType
from ascalon_web_api_client.models.training_set_doc import TrainingSetDoc
from ascalon_web_api_client.models.training_set_doc_defaults import TrainingSetDocDefaults
from ascalon_web_api_client.models.training_set_doc_statistics import TrainingSetDocStatistics
from ascalon_web_api_client.models.training_set_key import TrainingSetKey
from ascalon_web_api_client.models.training_set_modifiable import TrainingSetModifiable
from ascalon_web_api_client.models.training_set_status import TrainingSetStatus
from ascalon_web_api_client.models.training_set_status_modifiable import TrainingSetStatusModifiable
from ascalon_web_api_client.models.training_set_store_type import TrainingSetStoreType
from ascalon_web_api_client.models.transcribe_alt import TranscribeAlt
from ascalon_web_api_client.models.transfer import Transfer
from ascalon_web_api_client.models.transfer_all_of import TransferAllOf
from ascalon_web_api_client.models.websocket import Websocket
from ascalon_web_api_client.models.websocket_init import WebsocketInit
from ascalon_web_api_client.models.websocket_modifiable import WebsocketModifiable
from ascalon_web_api_client.models.websocket_msg import WebsocketMsg
from ascalon_web_api_client.models.websocket_resp import WebsocketResp
from ascalon_web_api_client.models.word_alternatives import WordAlternatives
from ascalon_web_api_client.models.word_correction import WordCorrection
from ascalon_web_api_client.models.word_item_timed import WordItemTimed
from ascalon_web_api_client.models.word_item_timing import WordItemTiming
from ascalon_web_api_client.models.word_tree_ids import WordTreeIds
from ascalon_web_api_client.models.word_tree_item import WordTreeItem
from ascalon_web_api_client.models.words_item import WordsItem
from ascalon_web_api_client.models.words_websocket_item import WordsWebsocketItem

